#include <stdio.h>
#include <stdlib.h>
#include "bmp.h"

#pragma pack(1)

typedef struct {
	unsigned short		bfType;
	unsigned long		bfSize;
	unsigned short		bfReserved1;
	unsigned short		bfReserved2;
	unsigned long		bfOffBits;
} BITMAPFILEHEADER;

typedef struct {
	unsigned long		biSize;
	long				biWidth;
	long				biHeight;
	unsigned short		biPlanes;
	unsigned short		biBitCount;
	unsigned long		biCompression;
	unsigned long		biSizeImage;
	long				biXPelsPerMeter;
	long				biYPelsPerMeter;
	unsigned long		biClrUsed;
	unsigned long		biClrImportant;
} BITMAPINFOHEADER;

#define RGB(r,g,b)			((unsigned long)(((unsigned char)(r) | ((unsigned short)((unsigned char)(g)) << 8)) | (((unsigned long)(unsigned char)(b)) << 16)))

/* 24bitȏ̃rbg}bvt@Cǂݍ */
int			Load24bitBMP(char *filename,PBITMAPDATA pbd)
{
	FILE					*fp;
	BITMAPFILEHEADER		bf;
	BITMAPINFOHEADER		bi;
	unsigned long			*dest;
	unsigned char			*pPat,*src;
	int						i,j,k,row_bytes;

	if ((fp = fopen(filename,"rb")) == 0)
		return 0;

	if (!fread(&bf,sizeof(BITMAPFILEHEADER),1,fp) || bf.bfType != 0x4D42 ||
		!fread(&bi,sizeof(BITMAPINFOHEADER),1,fp) || bi.biBitCount < 24 ||
		bi.biCompression)
	{
		fclose(fp);
		return 0;
	}

	row_bytes = (int)((bi.biBitCount * bi.biWidth + 31) / 32 * 4);
	bi.biSizeImage = row_bytes * bi.biHeight;

	pbd->nWidth = (int)bi.biWidth;
	pbd->nHeight = (int)bi.biHeight;
	pbd->dwDataSize = bi.biWidth * bi.biHeight * sizeof(long);

	if ((pbd->pBmp = (unsigned long *)malloc((size_t)pbd->dwDataSize)) == 0)
	{
		fclose(fp);
		return 0;
	}
	if ((pPat = (unsigned char *)calloc((size_t)bi.biSizeImage,1)) == 0)
	{
		free(pbd->pBmp);
		fclose(fp);
		return 0;
	}

	fseek(fp,bf.bfOffBits,SEEK_SET);
	fread(pPat,1,(size_t)bi.biSizeImage,fp);
	fclose(fp);

	for(k = 0,i = bi.biHeight - 1;i >= 0;i--,k++){
		src = pPat + i * row_bytes;
		dest = pbd->pBmp + k * bi.biWidth;
		if (bi.biBitCount == 24){
			for(j = bi.biWidth;j;j--,src += 3)
				*dest++ = RGB(src[2],src[1],src[0]);
		}else{
			for(j = bi.biWidth;j;j--)
				*dest++ = *src++;
		}
	}
	free(pPat);

	return 1;
}

/*  */
void		FreeBMP(PBITMAPDATA pbd)
{
	if (pbd->pBmp) free(pbd->pBmp);
}
