#include <windows.h>
#include "sc39.h"
#include "bmp.h"
#include "bmpproc.h"

VOID		OnPaint(HWND hWnd)
{
	PAINTSTRUCT		ps;

	BeginPaint(hWnd,&ps);

	BitBlt(
		ps.hdc,
		ps.rcPaint.left,
		ps.rcPaint.top,
		WIDTH(ps.rcPaint),
		HEIGHT(ps.rcPaint),
		ginf.hVDC,
		ps.rcPaint.left,
		ps.rcPaint.top,
		SRCCOPY);

	EndPaint(hWnd,&ps);
}

VOID		Result(HWND hWnd)
{
	INT			x,y;

	for(y = 0;y < ginf.bmpdata.nHeight;y++)
		for(x = 0;x < ginf.bmpdata.nWidth;x++)
			SetPixel(ginf.hVDC,x,y,
				ginf.bmpdata.pBmp[y * ginf.bmpdata.nWidth + x]);
}

LRESULT CALLBACK	WinProc(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	INT			ret;

	switch(Msg){
		case	WM_CREATE:
				return OnCreate(hWnd); /* init.c */

		case	WM_PAINT:
				OnPaint(hWnd);
				break;

		case	WM_CLOSE:
				if (ghThread) break; /* BASIC s͏IȂ */
				DestroyWindow(hWnd);
				break;

		case	WM_DESTROY:
				OnDestroy(hWnd); /* init.c */
				PostQuitMessage(0);
				break;

		case	WM_LBUTTONDOWN: /* EChENbNɒf */
				SetEvent(ginf.bas.proc_exparam);
				break;

		case	WM_USER: /* BASIC IbZ[W */
				if ((ret = (INT)wParam) != STATUS_NORMAL)
					errormes_V39(hWnd,ret,&ginf.bas);
				else{
					Result(hWnd);
					InvalidateRect(hWnd,NULL,FALSE);
				}
				CloseHandle(ghThread); ghThread = NULL;
				break;

		default:
				return DefWindowProc(hWnd,Msg,wParam,lParam);
	}

	return 0;
}

INT WINAPI		WinMain(
					HINSTANCE		hInstance,
					HINSTANCE		hPrevInstance,
					LPSTR			pszArgv,
					INT				nCmdShow)
{
	HWND			hWnd,hWndOwner = GetDesktopWindow();
	WNDCLASSEX		wcx;
	MSG				m;
	RECT			rect;
	INT				nRet;

	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = 0;
	wcx.hInstance = hInstance;
	wcx.hCursor = LoadCursor(NULL,IDC_ARROW);
	wcx.lpfnWndProc = (WNDPROC)WinProc;
	wcx.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcx.lpszClassName = gpszWinName;
	wcx.lpszMenuName = NULL;
	wcx.cbClsExtra = wcx.cbWndExtra = 0;
	wcx.hIcon = wcx.hIconSm = NULL;

	#define STYLE_DISABLE	(WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX)
	#define WINSTYLE		(WS_OVERLAPPEDWINDOW ^ STYLE_DISABLE)

	rect.right = WIN_WIDTH; rect.bottom = WIN_HEIGHT;
	rect.left = rect.top = 0;
	AdjustWindowRect(&rect,WINSTYLE,FALSE);

	if (!RegisterClassEx(&wcx) ||
		(hWnd = CreateWindowEx(
			0,gpszWinName,gpszWinName,WINSTYLE,
			CW_USEDEFAULT,CW_USEDEFAULT,
			WIDTH(rect),HEIGHT(rect),
			hWndOwner,NULL,hInstance,NULL)) == NULL)
		return 0;

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	while((nRet = (INT)GetMessage(&m,NULL,0,0)) != 0 && nRet != -1){
		TranslateMessage(&m);
		DispatchMessage(&m);
	}
	return m.wParam;
}
