#include <windows.h>
#include "sc39.h"
#include "graph.h"
#include "resource.h"

static BOOL		createVirtualWin(HDC hDC)
{
	return (ghDC = CreateCompatibleDC(hDC)) != NULL &&
		(ghBmp = CreateCompatibleBitmap(hDC,WIN_WIDTH,WIN_HEIGHT)) != NULL;
}

INT		OnCreate(HWND hWnd)
{
	HDC				hDC;
	BOOL			bRet;
	PARAM_INFO		pinf;

	if ((hDC = GetDC(hWnd)) == NULL)
		return -1;

	bRet = createVirtualWin(hDC);
	ReleaseDC(hWnd,hDC);
	if (bRet == FALSE)
		return -1;

	SelectObject(ghDC,ghBmp);
	SelectObject(ghDC,GetStockObject(BLACK_BRUSH));
	PatBlt(ghDC,0,0,WIN_WIDTH,WIN_HEIGHT,BLACKNESS);

	if ((ghCenterPen = CreatePen(PS_SOLID,1,RGB(0,0xff,0))) == NULL)
		return -1;

	SelectObject(ghDC,ghCenterPen);
	cx = WIN_WIDTH / 2;
	cy = WIN_HEIGHT / 2;
	CenterLine(cx,cy); /* calc.c */
	SelectObject(ghDC,GetStockObject(WHITE_PEN));

	pinf.type = PRM_SINGLE;
	strcpy(pinf.name,PARAM_NAME);
	pinf.btempflg = 0;

	return ((gbSuccessInit = StrCalc_init(&gsc)) == 0 ||
		StrCalc_new_param(&gsc,&pinf) <= 0)? -1 : 0;
}

VOID		OnClose(HWND hWnd)
{
	if (gbSuccessInit) StrCalc_term(&gsc);
	if (ghDC) DeleteDC(ghDC);
	if (ghBmp) DeleteObject(ghBmp);
	if (ghCenterPen) DeleteObject(ghCenterPen);
}
