#include <windows.h>
#include <math.h>
#include "sc39.h"
#include "gio.h"
#include "local.h"

static INT	draw_pie(
				PSTRCALC_PARAM		prm,
				LPSTR				arg,
				INT					len,
				BOOL				bfill)
{
	double		val[6];
	HPEN		hPen,hOldPen;
	HBRUSH		hBrush,hOldBrush;
	COLORREF	color;
	INT			x,y,r,ret;
	INT			lt_x,lt_y,rb_x,rb_y;
	INT			sx,sy,ex,ey;

	if ((ret = StrCalc_getargs(prm,&arg,val,6)) != STATUS_NORMAL)
		return ret;

	if (*arg)
		return STATUS_INVALIDARGS;

	if ((x = (INT)val[0]) < 0)
		x = 0;
	else if (x >= gnWidth)
		x = gnWidth - 1;
	if ((y = (INT)val[1]) < 0)
		y = 0;
	else if (y >= gnHeight)
		y = gnHeight - 1;

	r = (INT)val[2];

	lt_x = x - r;
	lt_y = y - r;
	rb_x = x + r;
	rb_y = y + r;
	ex = x + (INT)(cos(val[3]) * val[2]);
	ey = y + (INT)(sin(val[3]) * val[2]);
	sx = x + (INT)(cos(val[4]) * val[2]);
	sy = y + (INT)(sin(val[4]) * val[2]);

	hPen = CreatePen(PS_SOLID,1,color = (DWORD)val[5]);

	if (bfill == TRUE)
		hBrush = CreateSolidBrush(color);
	else
		hBrush = GetStockObject(NULL_BRUSH);

	hOldPen = SelectObject(ghDC,hPen);
	hOldBrush = SelectObject(ghDC,hBrush);
	Pie(ghDC,lt_x,lt_y,rb_x,rb_y,sx,sy,ex,ey);
	SelectObject(ghDC,hOldPen);
	SelectObject(ghDC,hOldBrush);

#ifdef SHOW_PROGRESS
	hOldPen = SelectObject(ghDC_main,hPen);
	hOldBrush = SelectObject(ghDC_main,hBrush);
	Pie(ghDC_main,lt_x,lt_y,rb_x,rb_y,sx,sy,ex,ey);
	SelectObject(ghDC_main,hOldPen);
	SelectObject(ghDC_main,hOldBrush);
#endif

	DeleteObject(hPen);
	if (bfill == TRUE)
		DeleteObject(hBrush);

	return STATUS_NORMAL;
}

/* `̕` */
DECLARE INT __stdcall	usr_pie(
							PSTRCALC_PARAM		prm,
							LPSTR				arg,
							INT					len,
							LPVOID				dmy)
{
	return draw_pie(prm,arg,len,FALSE);
}

/* hԂ`̕` */
DECLARE INT __stdcall	usr_fillpie(
							PSTRCALC_PARAM		prm,
							LPSTR				arg,
							INT					len,
							LPVOID				dmy)
{
	return draw_pie(prm,arg,len,TRUE);
}
