#include <windows.h>
#include "sc39.h"
#include "gio.h"
#include "local.h"

/*
  SHOW_PROGRESS `ꍇ́AEChEɂ`悵܂iʏ͉zEC
  hÊ݁jBptH[}X͗܂A`̐imF鎖ł܂B
*/

INT			OnCreate(HWND hWnd)
{
	HDC				hDC;

	ghDC = NULL;
	ghBmp = NULL;

	if ((hDC = GetDC(hWnd)) == NULL)
		return -1;

	if ((ghDC = CreateCompatibleDC(hDC)) != NULL)
		ghBmp = CreateCompatibleBitmap(hDC,gnWidth,gnHeight);

	ReleaseDC(hWnd,hDC);

	if (ghDC && !ghBmp){
		DeleteDC(ghDC);
		return -1;
	}

	SelectObject(ghDC,ghBmp);
	SelectObject(ghDC,GetStockObject(WHITE_PEN));
	SelectObject(ghDC,GetStockObject(BLACK_BRUSH));
	PatBlt(ghDC,0,0,gnWidth,gnHeight,PATCOPY);

	SetBkMode(ghDC,TRANSPARENT);

	return 0;
}

VOID		OnPaint(HWND hWnd)
{
	PAINTSTRUCT		ps;

	BeginPaint(hWnd,&ps);

	BitBlt(
		ps.hdc,
		ps.rcPaint.left,
		ps.rcPaint.top,
		WIDTH(ps.rcPaint),
		HEIGHT(ps.rcPaint),
		ghDC,
		ps.rcPaint.left,
		ps.rcPaint.top,
		SRCCOPY);

	EndPaint(hWnd,&ps);
}

static LRESULT CALLBACK		WindowProc(
								HWND		hWnd,
								UINT		uMsg,
								WPARAM		wParam,
								LPARAM		lParam)
{
	switch(uMsg){
		case	WM_CREATE:
				return OnCreate(hWnd);

		case	WM_CLOSE:
				break;

		case	WM_DESTROY:
				PostQuitMessage(0);
				break;

		case	WM_PAINT:
				OnPaint(hWnd);
				break;

		default:
				return DefWindowProc(hWnd,uMsg,wParam,lParam);
	}
	return 0;
}

DECLARE UINT __stdcall	grpWindow(PWININFO pinf)
{
	HWND			hWnd;
	WNDCLASSEX		wcx;
	MSG				m;
	RECT			rect;
	INT				nRet;

	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = 0;
	wcx.hInstance = pinf->hInst;
	wcx.hCursor = LoadCursor(NULL,IDC_ARROW);
	wcx.lpfnWndProc = (WNDPROC)WindowProc;
	wcx.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wcx.lpszClassName = pinf->pszWinName;
	wcx.lpszMenuName = NULL;
	wcx.cbClsExtra = wcx.cbWndExtra = 0;
	wcx.hIcon = wcx.hIconSm = NULL;

	#define STYLE_DISABLE	(WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX)
	#define WINSTYLE		(WS_OVERLAPPEDWINDOW ^ STYLE_DISABLE)

	rect.right = gnWidth = pinf->nWidth;
	rect.bottom = gnHeight = pinf->nHeight;
	rect.left = rect.top = 0;
	AdjustWindowRect(&rect,WINSTYLE,FALSE);

	if (!RegisterClassEx(&wcx) ||
		(hWnd = CreateWindowEx(
					0,
					pinf->pszWinName,
					pinf->pszWinName,
					WINSTYLE,
					CW_USEDEFAULT,
					CW_USEDEFAULT,
					WIDTH(rect),
					HEIGHT(rect),
					pinf->hWndOwner,
					NULL,
					wcx.hInstance,
					NULL)) == NULL)
		return 0;

	*pinf->phwChild = ghWnd = hWnd;

	ShowWindow(hWnd,SW_SHOW);
	UpdateWindow(hWnd);

	while((nRet = (INT)GetMessage(&m,NULL,0,0)) != 0 && nRet != -1){
		TranslateMessage(&m);
		DispatchMessage(&m);
	}

	if (ghDC) DeleteDC(ghDC);
	if (ghBmp) DeleteObject(ghBmp);

	return m.wParam;
}

DECLARE VOID __stdcall		grp_start(VOID)
{
#ifdef SHOW_PROGRESS
	ghDC_main = GetDC(ghWnd);
	SetBkMode(ghDC_main,TRANSPARENT);
#endif
}

DECLARE VOID __stdcall		grp_end(VOID)
{
	InvalidateRect(ghWnd,NULL,FALSE);
#ifdef SHOW_PROGRESS
	ReleaseDC(ghWnd,ghDC_main);
#endif
}
