#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <mbstring.h>
#include <ctype.h>
#include "sc39.h"
#include "textedit.h"

#define STATUS_OTHERCHECK		-2147483647

/* 󔒁E^u΂ */
static LPSTR	jmp_space(LPSTR ptr)
{
	do{
		ptr++;
	}while(isspace(*ptr));

	return ptr;
}

/*  */
static INT		lend(TEXTEDIT_CALLBACK pfunc,LPVOID param)
{
	static CHAR		cRet = '\n';

	return pfunc(&cRet,1,TRUE,param);
}

static LPSTR	singlequote(LPSTR ptr)
{
	LPSTR	ps = ptr;
	INT		temp,cnt;

	temp = *ptr;
	for(cnt = 3;*++ptr && (*ptr != '\'' || temp == '\\') && cnt;cnt--)
		temp = (temp == '\\')? 0 : *ptr;

	return (cnt)? ptr : ps + 1;
}

/* _uNH[gŊꂽ̏ */
static INT		doublequote(
					PSTRCALC_PARAM		prm,
					LPSTR				*ppstr,
					TEXTEDIT_CALLBACK	pfunc,
					LPVOID				param)
{
	LPSTR	pstart,ptr = *ppstr;
	INT		ret;

	/*
	  ݈ʒu`̃_uNH[g܂͖܂ł͈̔
	  \
	*/
	pstart = ++ptr;
	while(*ptr && *ptr != '\"'){
		if (*ptr == '\''){
			ptr = singlequote(ptr);
			ptr += (*ptr != 0);
		}else
			ptr = (LPSTR)_mbsinc((LPBYTE)ptr);
	}

	ret = pfunc(pstart,ptr - pstart,FALSE,param);
	if (ret != STATUS_NORMAL)
		return ret;

	ptr += *ptr != 0;
	while(isspace(*ptr))
		ptr++;

	if (*ptr && *ptr != ';')
		return STATUS_ERROR;

	*ppstr = ptr;
	return STATUS_NORMAL;
}

/* insspc */
static INT		insspc(
					PSTRCALC_PARAM		prm,
					LPSTR				*ppstr,
					TEXTEDIT_CALLBACK	pfunc,
					LPVOID				param)
{
	LPSTR	ptr = *ppstr;
	INT		t,ret;

	if (_strnicmp(ptr,"insspc",6) || !isspace(ptr[6]))
		return STATUS_OTHERCHECK;

	ptr = StrCalc_search_char(
			prm->str = (ptr += 6 + 1),";");
	t = *ptr;
	*ptr = 0;

	if ((ret = StrCalc(prm)) != STATUS_NORMAL)
		return ret;
	*(*ppstr = ptr) = (CHAR)t;

	if ((t = (INT)prm->ans) < 0) /* ̏ꍇ̓G[ */
		return STATUS_ILLEGALFUNCTIONCALL;
	else if (t){
		LPSTR		pdest;

		if ((pdest = (LPSTR)malloc(t)) == NULL)
			return STATUS_NOTENOUGHMEM;
		memset(pdest,' ',t);

		ret = pfunc(pdest,t,FALSE,param);

		free(pdest);
	}

	return ret;
}

/* chr */
static INT		character(
					PSTRCALC_PARAM		prm,
					LPSTR				*ppstr,
					TEXTEDIT_CALLBACK	pfunc,
					LPVOID				param)
{
	LPSTR	ptr = *ppstr;
	CHAR	c;
	INT		t,ret;

	if (_strnicmp(ptr,"chr",3) || !isspace(ptr[3]))
		return STATUS_OTHERCHECK;

	ptr = StrCalc_search_char(
			prm->str = (ptr += 3 + 1),";");
	t = *ptr;
	*ptr = 0;

	if ((ret = StrCalc(prm)) != STATUS_NORMAL)
		return ret;
	*(*ppstr = ptr) = (CHAR)t;

	c = (BYTE)prm->ans;
	return pfunc(&c,1,FALSE,param);
}

/* str */
static INT		string(
					PSTRCALC_PARAM		prm,
					LPSTR				*ppstr,
					TEXTEDIT_CALLBACK	pfunc,
					LPVOID				param)
{
	LPSTR			ptr = *ppstr,pdest;
	CHAR			buf[SC_MAX_PARAMNAME+1];
	PARAM_INFO		pi;
	INT				len,i,ret;

	if (_strnicmp(ptr,"str",3) || !isspace(ptr[3]))
		return STATUS_OTHERCHECK;

	/* ϐ𒊏o */
	ptr += 3 + 1;
	len = SC_MAX_PARAMNAME;
	for(pdest = buf;*ptr && *ptr != ';';ptr++){
		if (isspace(*ptr))
			continue;

		if (!len)
			break;
		*pdest++ = *ptr;
		len--;
	}
	*pdest = 0;
	*ppstr = ptr; /* |C^Ăяo֔f */

	/* ؂蕶łȂꍇ̓G[ */
	if (*ptr && *ptr != ';')
		return STATUS_ILLEGAL_PARAMNAME;

	/* ϐꎟzł͂Ȃꍇ̓G[ */
	if (!StrCalc_search_param(prm,buf,&pi) || pi.type != PRM_DIM1)
		return STATUS_ILLEGAL_PARAMNAME;

	/* ꎟz̓e𕶎ƌȂ */

	for(len = 0;len < pi.width;len++){ /* 𒲂ׂ */
		if (pi.pval[len] == 0.0) /*  0 Ƃ */
			break;
	}

	if (!len) /*  0 ̏ꍇ͏I */
		return STATUS_NORMAL;

	if ((pdest = malloc(len)) == NULL) /* f[^i[p */
		return STATUS_NOTENOUGHMEM;

	/* zf[^ char ^ɕϊ */
	i = 0;
	do{
		pdest[i] = (BYTE)pi.pval[i];
	}while(++i < len);

	ret = pfunc(pdest,len,FALSE,param); /* o */

	free(pdest);

	return ret;
}

/* ftHg */
static INT		defaultproc(
					PSTRCALC_PARAM		prm,
					LPSTR				*ppstr,
					TEXTEDIT_CALLBACK	pfunc,
					LPVOID				param)
{
	LPSTR		ptr = *ppstr;
	CHAR		buf[32];
	INT			t,ret;
	DWORD		lout;

	/*
	  ݈ʒu`Z~R܂͖܂ł͈̔͂vZA
	  ŕ\
	*/
	ptr = StrCalc_search_char(prm->str = ptr,";");
	t = *ptr;
	*ptr = 0;

	if ((ret = StrCalc(prm)) != STATUS_NORMAL)
		return ret;
	*(*ppstr = ptr) = (CHAR)t;

	lout = sprintf(buf,"%.16G",prm->ans);
	return pfunc(buf,lout,FALSE,param);
}

/* 񎮂̕ҏW */
DECLARE INT __stdcall	text_edit(
							PSTRCALC_PARAM		prm,
							LPSTR				ptr,
							TEXTEDIT_CALLBACK	pfunc,
							LPVOID				param)
{
	INT		ret,loop;

	loop = 1;

	do{
		switch(*ptr){
			case	0:
					ret = lend(pfunc,param);
					if (ret != STATUS_NORMAL)
						return ret;
					loop = 0;
					break;

			case	'\t': /* NH[gŊĂȂ󔒂͔΂ */
			case	' ':
					ptr = jmp_space(ptr);
					break;

			case	'\"': /*  */
					ret = doublequote(prm,&ptr,pfunc,param);
					if (ret != STATUS_NORMAL)
						return ret;
					break;

			case	';': /* ڍ */
					/*
					  Z~RŏIĂꍇ́A
					  stȂ
					*/
					if (!*(ptr = jmp_space(ptr)))
						loop = 0;
					break;

			case	'i': /* 󔒂̑} */
			case	'I':
					ret = insspc(prm,&ptr,pfunc,param);
					if (ret == STATUS_NORMAL)
						break;
					else if (ret != STATUS_OTHERCHECK)
						return ret;
					ret = defaultproc(prm,&ptr,pfunc,param);
					if (ret != STATUS_NORMAL)
						return ret;
					break;

			case	's': /* ꎟz̓e𕶎ƌȂ\ */
			case	'S':
					ret = string(prm,&ptr,pfunc,param);
					if (ret == STATUS_NORMAL)
						break;
					else if (ret != STATUS_OTHERCHECK)
						return ret;
					ret = defaultproc(prm,&ptr,pfunc,param);
					if (ret != STATUS_NORMAL)
						return ret;
					break;

			case	'c':
			case	'C':
					ret = character(prm,&ptr,pfunc,param);
					if (ret == STATUS_NORMAL)
						break;
					else if (ret != STATUS_OTHERCHECK)
						return ret;

			default:
					ret = defaultproc(prm,&ptr,pfunc,param);
					if (ret != STATUS_NORMAL)
						return ret;
					break;
		}
	}while(loop);

	return STATUS_NORMAL;
}

