#include <windows.h>
#include "sc39x64.h"
#include "graph.h"
#include "resource.h"

VOID		OnPaint(HWND hWnd)
{
	PAINTSTRUCT		ps;

	BeginPaint(hWnd,&ps);

	BitBlt(
		ps.hdc,
		ps.rcPaint.left,
		ps.rcPaint.top,
		ps.rcPaint.right - ps.rcPaint.left,
		ps.rcPaint.bottom - ps.rcPaint.top,
		ghDC,
		ps.rcPaint.left,
		ps.rcPaint.top,
		SRCCOPY);

	EndPaint(hWnd,&ps);
}

LRESULT CALLBACK	WindowProc(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	INT64		ret;

	switch(Msg){
		case	WM_CREATE:
				return OnCreate(hWnd); /* init.c */

		case	WM_PAINT:
				OnPaint(hWnd);
				break;

		case	WM_CLOSE:
				DestroyWindow(hWnd);
				break;

		case	WM_DESTROY:
				OnClose(hWnd); /* init.c */
				PostQuitMessage(0);
				break;

		case	WM_LBUTTONDOWN:
				OnLButtonDown(hWnd,lParam); /* drag.c */
				break;

		case	WM_MOUSEMOVE:
				OnMouseMove(hWnd,lParam); /* drag.c */
				break;

		case	WM_LBUTTONUP:
				OnLButtonUp(hWnd,lParam); /* drag.c */
				break;

		case	WM_RBUTTONDOWN:
				OnRButtonDown(hWnd,lParam); /* drag.c */
				break;

		case	WM_MOUSEWHEEL: /* }EXzC[Cxg */
				/*
				  zC[Ŕ{ 1 ύX܂B
				  傫ύXꍇ́Aj[́u{̐ݒv(IDM_MAG)
				  IĂB
				*/
				if ((INT)wParam < 0)
					mag++;
				else if (mag)
					mag--;

				if (mag <= 0.0)
					mag = 1.0;
				Calc(hWnd,cx,cy); /* calc.c */
				break;

		case	WM_COMMAND:
				switch(LOWORD(wParam)){
					case	IDM_EXIT:
							DestroyWindow(hWnd);
							break;

					case	IDM_RESETPOS: /* ʒu */
							cx = WIN_WIDTH / 2;
							cy = WIN_HEIGHT / 2;

					case	IDM_START: /* vZJn */
							Calc(hWnd,cx,cy); /* calc.c */
							break;

					case	IDM_SET: /* vZ̐ݒ */
							if (StrSet(hWnd) == FALSE) /* str.c */
								break;

							/* ͂ꂽvZĂ݂icalc.cj */
							if ((ret = Calc(hWnd,cx,cy)) != STATUS_NORMAL){
								/* G[̏ꍇ̓bZ[W\ (error.c) */
								MessageBox(hWnd,errormes(ret),gpszWinName,
									MB_OK | MB_ICONHAND);
							}
							break;

					case	IDM_MAG: /* {̐ݒ */
							if (MagSet(hWnd) == FALSE) /* mag.c */
								break;
							Calc(hWnd,cx,cy); /* calc.c */
							break;

				}
				break;

		default:
				return DefWindowProc(hWnd,Msg,wParam,lParam);
	}
	return 0;
}

INT WINAPI		WinMain(
					HINSTANCE		hInstance,
					HINSTANCE		hPrevInstance,
					LPSTR			pszArgv,
					INT				nCmdShow)
{
	HWND			hWnd,hWndOwner = GetDesktopWindow();
	WNDCLASSEX		wcx;
	MSG				m;
	RECT			rect;
	INT				nRet;

	ghInst = hInstance;

	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = 0;
	wcx.hInstance = hInstance;
	wcx.hCursor = LoadCursor(NULL,IDC_ARROW);
	wcx.lpfnWndProc = (WNDPROC)WindowProc;
	wcx.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wcx.lpszClassName = gpszWinName;
	wcx.lpszMenuName = MAKEINTRESOURCE(IDR_MENU1);
	wcx.cbClsExtra = wcx.cbWndExtra = 0;
	wcx.hIcon = wcx.hIconSm = NULL;

	#define STYLE_DISABLE	(WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX)
	#define WINSTYLE		(WS_OVERLAPPEDWINDOW ^ STYLE_DISABLE)

	rect.right = WIN_WIDTH;
	rect.bottom = WIN_HEIGHT;
	rect.left = rect.top = 0;
	AdjustWindowRect(&rect,WINSTYLE,TRUE);

	if (!RegisterClassEx(&wcx) ||
		(hWnd = CreateWindowEx(
			WS_EX_APPWINDOW,gpszWinName,gpszWinName,
			WINSTYLE,CW_USEDEFAULT,CW_USEDEFAULT,
			rect.right - rect.left,rect.bottom - rect.top,
			hWndOwner,NULL,wcx.hInstance,NULL)) == NULL)
		return 0;

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	while((nRet = (INT)GetMessage(&m,NULL,0,0)) != 0 && nRet != -1){
		TranslateMessage(&m);
		DispatchMessage(&m);
	}

	return (INT)m.wParam;
}
