#ifndef ___PLOTTER_H_ONCE
#define ___PLOTTER_H_ONCE

#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include "sc39x64.h"

#define WIN_WIDTH				640
#define WIN_HEIGHT				480
#define DEF_PENCOLOR			RGB(0xff,0xff,0xff)

#define ORG_X					0.0
#define ORG_Y					0.0

#define STATUS_CHANGEPEN_ERROR	(STATUS_USERABORT - 1)

#define SRC_FILE				"basic.txt"

typedef INT64					*LPINT64;
typedef UINT64					*LPUINT64;

typedef UINT		(*THREAD_ROUTINE)(LPVOID);

LRESULT				OnCreate(HWND);
VOID				OnClose(HWND);
VOID				OnPaint(HWND);
VOID				OnUser(HWND,INT64);
LPSTR				LoadFile(LPSTR,LPUINT64);

LRESULT CALLBACK	WndProc(HWND,UINT,WPARAM,LPARAM);

UINT				basic_proc(HWND);

INT64				usr_move(PSTRCALC_PARAM,LPSTR,INT64,LPVOID);
INT64				usr_draw(PSTRCALC_PARAM,LPSTR,INT64,LPVOID);
INT64				usr_chpen(PSTRCALC_PARAM,LPSTR,INT64,LPVOID);
INT64				usr_resetpos(PSTRCALC_PARAM,LPSTR,INT64,LPVOID);

double				user_f_mkrgb(double *,INT64,LPINT64,LPVOID);

INT64				func_stopevent(PSTRCALC_PARAM,LPVOID);

#ifdef ___MAIN_OBJECT
LPSTR					gpszWinName = "plotter";
LPSTR					gpszWinName_stop = "plotter - ~";
LPSTR					gpsrc;
UINT64					gsize;
STRCALC_PARAM			gsc;
BASICPARAM				gbas;
HANDLE					ghThread;
HANDLE					ghStop;
HDC						ghDC,ghVDC;
HBITMAP					ghVBmp;
HPEN					ghPen;
double					gx,gy;
#else
extern LPSTR			gpszWinName;
extern LPSTR			gpszWinName_stop;
extern LPSTR			gpsrc;
extern UINT64			gsize;
extern STRCALC_PARAM	gsc;
extern BASICPARAM		gbas;
extern HANDLE			ghThread;
extern HANDLE			ghStop;
extern HDC				ghDC,ghVDC;
extern HBITMAP			ghVBmp;
extern HPEN				ghPen;
extern double			gx,gy;
#endif

#endif
