#include <windows.h>
#include "sc39x64.h"
#include "gio.h"
#include "local.h"

static INT64	draw_circle(
					PSTRCALC_PARAM		prm,
					LPSTR				arg,
					INT64				len,
					BOOL				bfill)
{
	double		val[4];
	HPEN		hPen,hOldPen;
	HBRUSH		hBrush,hOldBrush;
	COLORREF	color;
	INT64		ret;
	INT			x,y,r,sx,sy,ex,ey;

	if ((ret = StrCalc_getargs(prm,&arg,val,4)) != STATUS_NORMAL)
		return ret;

	if (*arg)
		return STATUS_INVALIDARGS;

	if ((x = (INT)val[0]) < 0)
		x = 0;
	else if (x >= gnWidth)
		x = gnWidth - 1;
	if ((y = (INT)val[1]) < 0)
		y = 0;
	else if (y >= gnHeight)
		y = gnHeight - 1;

	r = (INT)val[2];

	sx = x - r;
	sy = y - r;
	ex = x + r;
	ey = y + r;

	hPen = CreatePen(PS_SOLID,1,color = (DWORD)val[3]);

	if (bfill == TRUE)
		hBrush = CreateSolidBrush(color);
	else
		hBrush = GetStockObject(NULL_BRUSH);

	hOldPen = SelectObject(ghDC,hPen);
	hOldBrush = SelectObject(ghDC,hBrush);
	Chord(ghDC,sx,sy,ex,ey,sx,sy,sx,sy);
	SelectObject(ghDC,hOldPen);
	SelectObject(ghDC,hOldBrush);

#ifdef SHOW_PROGRESS
	hOldPen = SelectObject(ghDC_main,hPen);
	hOldBrush = SelectObject(ghDC_main,hBrush);
	Chord(ghDC_main,sx,sy,ex,ey,sx,sy,sx,sy);
	SelectObject(ghDC_main,hOldPen);
	SelectObject(ghDC_main,hOldBrush);
#endif

	DeleteObject(hPen);
	if (bfill == TRUE)
		DeleteObject(hBrush);

	return STATUS_NORMAL;
}

/* ~̕` */
DECLARE INT64	usr_circle(
					PSTRCALC_PARAM		prm,
					LPSTR				arg,
					INT64				len,
					LPVOID				dmy)
{
	return draw_circle(prm,arg,len,FALSE);
}

/* hԂ~̕` */
DECLARE INT64	usr_fillcircle(
					PSTRCALC_PARAM		prm,
					LPSTR				arg,
					INT64				len,
					LPVOID				dmy)
{
	return draw_circle(prm,arg,len,TRUE);
}
