/*
  StrCalc 3.9.5 x64
      by RFiY.Koyamaj2014 - 2018
*/
#ifndef ___STRCALC39_x64_H_ONCE
#define ___STRCALC39_x64_H_ONCE

#ifdef __cplusplus
extern "C"{
#endif

#define SC_MAX_PARAMNAME		33

typedef struct {
	__int64			reserved1;
	char			*str;
	__int64			reserved2;
	__int64			paren_cnt;
	double			ans;
	char			**ppcheck_paramname;
	__int64			nametbl_cnt;
	__int64			b_hexchk;
	double			*pmem;
	__int64			memmax;
	__int64			reserved3[54];
} STRCALC_PARAM,*PSTRCALC_PARAM;

typedef struct {
	char				name[SC_MAX_PARAMNAME+15];
	unsigned __int64	type;
	double				*pval;
	__int64				width;
	__int64				height;
	__int64				btempflg;
	__int64				reserved;
} PARAM_INFO,*PPARAM_INFO;

enum{ PRM_SINGLE = 0, PRM_DIM1, PRM_DIM2 };

typedef __int64	(*APPPROC)(PSTRCALC_PARAM,void *);
typedef __int64 (*USFUNC)(PSTRCALC_PARAM,char *,__int64,void *);
typedef __int64	(*EP_CALLBACK)(PPARAM_INFO,void *);
typedef double	(*MFUNC)(double *,__int64,__int64 *,void *);
typedef __int64	(*SUBSTHOOK)(
					PSTRCALC_PARAM,char *,__int64,__int64,__int64 *,void *);

typedef struct {
	char			*name;
	__int64			len;
	USFUNC			func;
	void			*param;
} USERSTATEMENT,*PUSERSTATEMENT;

typedef struct {
	char				*psource;
	unsigned __int64	src_size;

	unsigned __int64	random_seed;
	__int64				stackcnt_if;
	__int64				stackcnt_for;
	__int64				stackcnt_gosub;
	__int64				b_localparam;
	__int64				b_ignore_subcnt;
	__int64				b_remark_colontype;
	__int64				b_remark_ignorestr;
	__int64				b_check_dup_label;
	__int64				b_naked_us;
	__int64				b_us_check;
	__int64				b_removespace;
	__int64				b_srand;

	__int64				reserved1[11];

	APPPROC				fprologue;
	APPPROC				fevery;
	APPPROC				fepilogue;
	void				*proc_exparam;

	PUSERSTATEMENT		pus;
	__int64				uscnt;

	SUBSTHOOK			psubst;
	void				*subst_exparam;

	unsigned __int64	stop_lineno;
	__int64				sc_ret;
} BASICPARAM,*PBASICPARAM;

#define MAX_VERSTR				(128 + 8)

typedef struct {
	__int64			top,mid,bottom;
	__int64			bNormal;
	__int64			reserved;
	char			ver[MAX_VERSTR];
} SCVER,*PSCVER;

#define SCDECLARE				__declspec(dllimport)

SCDECLARE __int64	StrCalc_init(PSTRCALC_PARAM);
SCDECLARE __int64	StrCalc(PSTRCALC_PARAM);
SCDECLARE __int64 	StrCalc_n(PSTRCALC_PARAM,char *,__int64);
SCDECLARE __int64	StrCalc_BASIC(PSTRCALC_PARAM,PBASICPARAM);
SCDECLARE void		StrCalc_term(PSTRCALC_PARAM);
SCDECLARE __int64	StrCalc_setfunc(
						PSTRCALC_PARAM,char *,__int64,MFUNC,void *);
SCDECLARE __int64	StrCalc_setconst(PSTRCALC_PARAM,char *,double);
SCDECLARE __int64	StrCalc_new_param(PSTRCALC_PARAM,PPARAM_INFO);
SCDECLARE __int64	StrCalc_check_paramname(PSTRCALC_PARAM,char *);
SCDECLARE __int64	StrCalc_delete_param(PSTRCALC_PARAM,char *);
SCDECLARE __int64	StrCalc_delete_userfunc(PSTRCALC_PARAM,char *);
SCDECLARE __int64	StrCalc_delete_param_all(PSTRCALC_PARAM);
SCDECLARE __int64	StrCalc_delete_tempparam(PSTRCALC_PARAM);
SCDECLARE __int64	StrCalc_substitution(
						PSTRCALC_PARAM,
						char *,
						__int64,
						PPARAM_INFO,
						__int64 *,
						__int64 *);
SCDECLARE __int64	StrCalc_substitution_n(
						PSTRCALC_PARAM,
						char *,
						__int64,
						__int64,
						PPARAM_INFO,
						__int64 *,
						__int64 *);
SCDECLARE __int64	StrCalc_getargs(
						PSTRCALC_PARAM,char **,double *,__int64);
SCDECLARE __int64	StrCalc_get_parenargs(
						PSTRCALC_PARAM,char **,double *,__int64);
SCDECLARE __int64	StrCalc_get_paramname(
						PSTRCALC_PARAM,
						char **,
						PPARAM_INFO,
						__int64 *,
						__int64 *);
SCDECLARE char		*StrCalc_search_word(char *,char *,char *,__int64);
SCDECLARE char		*StrCalc_search_char(char *,char *);
SCDECLARE char		*StrCalc_stringcopy(char *,char *,__int64);
SCDECLARE char		*StrCalc_getword(char *,char *,__int64,char **);
SCDECLARE __int64	StrCalc_search_param(PSTRCALC_PARAM,char *,PPARAM_INFO);
SCDECLARE __int64	StrCalc_enumerate_param(
						PSTRCALC_PARAM,EP_CALLBACK,void *);
SCDECLARE void		StrCalc_copy_paraminfo(PSTRCALC_PARAM,PSTRCALC_PARAM);
SCDECLARE __int64	StrCalc_issep(__int64);
SCDECLARE __int64	StrCalc_set_tempflag(PSTRCALC_PARAM,char *,__int64);
SCDECLARE void		StrCalc_srand(unsigned __int64);
SCDECLARE void		StrCalc_fpreset(void);
SCDECLARE void		StrCalc_getversion(PSCVER);

enum {
	STATUS_NORMAL = 0,
	STATUS_ERROR = -1,
	STATUS_DIVIDEBYZERO = -2,
	STATUS_ILLEGAL_POWER = -3,
	STATUS_ILLEGALPARENTHESIS = -4,
	STATUS_PARENTHESIS_OVERNEST = -5,
	STATUS_MEMERROR = -6,
	STATUS_TOOMANYITEM = -7,
	STATUS_INVALIDARGS = -8,
	STATUS_ILLEGALFUNCTIONCALL = -9,
	STATUS_RANGEOVER = -10,
	STATUS_TOOLONGNUM = -11,
	STATUS_OP_ERROR = -12,
	STATUS_ILLEGALNUM_BIN = -13,
	STATUS_ILLEGALNUM_OCT = -14,
	STATUS_ILLEGALNUM_DEC = -15,
	STATUS_ILLEGALNUM_HEX = -16,
	STATUS_ONLY_PERIOD = -17,
	STATUS_INVALID_RADIX = -18,
	STATUS_ILLEGALNUM_FP = -19,
	STATUS_PARAM_RANGEOVER = -20,
	STATUS_ILLEGALNUM_STR = -21,
	STATUS_NEED_START_PAREN = -22,
	STATUS_NEED_LAST_PAREN = -23,
	STATUS_CONSTCHR_SYNTAXERROR = -24,
	STATUS_CONSTCHR_NEED_SQ = -25,
	STATUS_SCMEMORY_NOTREADY = -26,
	STATUS_SCMEMORY_RANGEOVER = -27,
	STATUS_BROKEN_PARAMETER_INFO = -28,
	STATUS_ILLEGAL_PARAMNAME = -29,
	STATUS_DUPLICATE_DEFINITION = -30,
	STATUS_NEED_EQUAL = -31,
	STATUS_SUBST_SYNTAXERROR = -32,

	STATUS_NOTENOUGHMEM = -100,
	STATUS_GOSUB_STACKOVERFLOW = -101,
	STATUS_IF_WITHOUT_THEN = -102,
	STATUS_IFBLOCK_STACKOVERFLOW = -103,
	STATUS_LABEL_SYNTAXERROR = -104,
	STATUS_ELSE_WITHOUT_IF = -105,
	STATUS_ELSE_SYNTAXERROR = -106,
	STATUS_ENDIF_WITHOUT_IF = -107,
	STATUS_ENDIF_SYNTAXERROR = -108,
	STATUS_THEN_SYNTAXERROR = -109,
	STATUS_CONTINUE_WITHOUT_FOR = -110,
	STATUS_BREAK_WITHOUT_FOR = -111,
	STATUS_NEXT_WITHOUT_FOR = -112,
	STATUS_FOR_WITHOUT_TO = -113,
	STATUS_FORLOOP_STACKOVERFLOW = -114,
	STATUS_NEXT_SYNTAXERROR = -115,
	STATUS_ON_WITHOUT_GOTO = -116,
	STATUS_UNDEFINED_USERSTATEMENT = -117,
	STATUS_IF_WITHOUT_ENDIF = -118,
	STATUS_FOR_WITHOUT_NEXT = -119,
	STATUS_UNDEFINED_LABEL = -120,
	STATUS_RETURN_WITHOUT_GOSUB = -121,
	STATUS_GOSUB_WITHOUT_RETURN = -122,
	STATUS_ILLEGAL_FORLOOP = -123,
	STATUS_IFSTACK_INITERR = -124,
	STATUS_FORSTACK_INITERR = -125,
	STATUS_GOSUBSTACK_INITERR = -126,
	STATUS_USERSTATEMENT_INITERR = -127,
	STATUS_DUPLICATE_LABEL = -128,
	STATUS_INVALID_NULLTERMINATION = -129,
	STATUS_UNDEFINED_PARAM = -130,
	STATUS_OUTOFDATA = -131,
	STATUS_UNDEFINED_DATALABEL = -132,

	STATUS_IF_CMP_ERROR = -200,
	STATUS_BREAK_CMP_ERROR = -201,
	STATUS_FOR_INIT_ERROR = -202,
	STATUS_FOR_CMP_ERROR = -203,
	STATUS_FOR_STEP_ERROR = -204,
	STATUS_CONTINUE_CMP_ERROR = -205,
	STATUS_ONGOTO_INDEX_ERROR = -206,
	STATUS_SUBST_ERROR = -207,
	STATUS_DIM_ERROR = -208,
	STATUS_RETURN_CMP_ERROR = -209,
	STATUS_END_CMP_ERROR = -210,
	STATUS_READ_ERROR = -211,
	STATUS_SKIP_ERROR = -212,

	STATUS_USERABORT = -900
};

#ifdef __cplusplus
}
#endif

#endif
